/*   -*- buffer-read-only: t -*- vi: set ro:
 *
 *  DO NOT EDIT THIS FILE   (certtool-args.h)
 *
 *  It has been AutoGen-ed  December 18, 2021 at 01:42:37 AM by AutoGen 5.18
 *  From the definitions    certtool-args.def
 *  and the template file   options
 *
 * Generated from AutoOpts 40:0:15 templates.
 *
 *  AutoOpts is a copyrighted work.  This header file is not encumbered
 *  by AutoOpts licensing, but is provided under the licensing terms chosen
 *  by the certtool author or copyright holder.  AutoOpts is
 *  licensed under the terms of the LGPL.  The redistributable library
 *  (``libopts'') is licensed under the terms of either the LGPL or, at the
 *  users discretion, the BSD license.  See the AutoOpts and/or libopts sources
 *  for details.
 *
 * The certtool program is copyrighted and licensed
 * under the following terms:
 *
 *  Copyright (C) 2000-2020 Free Software Foundation, and others, all rights reserved.
 *  This is free software. It is licensed for use, modification and
 *  redistribution under the terms of the GNU General Public License,
 *  version 3 or later <http://gnu.org/licenses/gpl.html>
 *
 *  certtool is free software: you can redistribute it and/or modify it
 *  under the terms of the GNU General Public License as published by the
 *  Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  certtool is distributed in the hope that it will be useful, but
 *  WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *  See the GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License along
 *  with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
/**
 *  This file contains the programmatic interface to the Automated
 *  Options generated for the certtool program.
 *  These macros are documented in the AutoGen info file in the
 *  "AutoOpts" chapter.  Please refer to that doc for usage help.
 */
#ifndef AUTOOPTS_CERTTOOL_ARGS_H_GUARD
#define AUTOOPTS_CERTTOOL_ARGS_H_GUARD 1
#include "config.h"
#include <autoopts/options.h>

/**
 *  Ensure that the library used for compiling this generated header is at
 *  least as new as the version current when the header template was released
 *  (not counting patch version increments).  Also ensure that the oldest
 *  tolerable version is at least as old as what was current when the header
 *  template was released.
 */
#define AO_TEMPLATE_VERSION 163840
#if (AO_TEMPLATE_VERSION < OPTIONS_MINIMUM_VERSION) \
 || (AO_TEMPLATE_VERSION > OPTIONS_STRUCT_VERSION)
# error option template version mismatches autoopts/options.h header
  Choke Me.
#endif

/**
 *  Enumeration of each option type for certtool
 */
typedef enum {
    INDEX_OPT_DEBUG                    =  0,
    INDEX_OPT_VERBOSE                  =  1,
    INDEX_OPT_INFILE                   =  2,
    INDEX_OPT_OUTFILE                  =  3,
    INDEX_OPT_CERTIFICATE_INFO         =  5,
    INDEX_OPT_PUBKEY_INFO              =  6,
    INDEX_OPT_GENERATE_SELF_SIGNED     =  7,
    INDEX_OPT_GENERATE_CERTIFICATE     =  8,
    INDEX_OPT_GENERATE_PROXY           =  9,
    INDEX_OPT_UPDATE_CERTIFICATE       = 10,
    INDEX_OPT_FINGERPRINT              = 11,
    INDEX_OPT_KEY_ID                   = 12,
    INDEX_OPT_CERTIFICATE_PUBKEY       = 13,
    INDEX_OPT_V1                       = 14,
    INDEX_OPT_SIGN_PARAMS              = 15,
    INDEX_OPT_CRQ_INFO                 = 17,
    INDEX_OPT_GENERATE_REQUEST         = 18,
    INDEX_OPT_NO_CRQ_EXTENSIONS        = 19,
    INDEX_OPT_P12_INFO                 = 21,
    INDEX_OPT_P12_NAME                 = 22,
    INDEX_OPT_TO_P12                   = 23,
    INDEX_OPT_KEY_INFO                 = 25,
    INDEX_OPT_P8_INFO                  = 26,
    INDEX_OPT_TO_RSA                   = 27,
    INDEX_OPT_GENERATE_PRIVKEY         = 28,
    INDEX_OPT_KEY_TYPE                 = 29,
    INDEX_OPT_BITS                     = 30,
    INDEX_OPT_CURVE                    = 31,
    INDEX_OPT_SEC_PARAM                = 32,
    INDEX_OPT_TO_P8                    = 33,
    INDEX_OPT_PKCS8                    = 34,
    INDEX_OPT_PROVABLE                 = 35,
    INDEX_OPT_VERIFY_PROVABLE_PRIVKEY  = 36,
    INDEX_OPT_SEED                     = 37,
    INDEX_OPT_CRL_INFO                 = 39,
    INDEX_OPT_GENERATE_CRL             = 40,
    INDEX_OPT_VERIFY_CRL               = 41,
    INDEX_OPT_VERIFY_CHAIN             = 43,
    INDEX_OPT_VERIFY                   = 44,
    INDEX_OPT_VERIFY_HOSTNAME          = 45,
    INDEX_OPT_VERIFY_EMAIL             = 46,
    INDEX_OPT_VERIFY_PURPOSE           = 47,
    INDEX_OPT_VERIFY_ALLOW_BROKEN      = 48,
    INDEX_OPT_VERIFY_PROFILE           = 49,
    INDEX_OPT_P7_GENERATE              = 51,
    INDEX_OPT_P7_SIGN                  = 52,
    INDEX_OPT_P7_DETACHED_SIGN         = 53,
    INDEX_OPT_P7_INCLUDE_CERT          = 54,
    INDEX_OPT_P7_TIME                  = 55,
    INDEX_OPT_P7_SHOW_DATA             = 56,
    INDEX_OPT_P7_INFO                  = 57,
    INDEX_OPT_P7_VERIFY                = 58,
    INDEX_OPT_SMIME_TO_P7              = 59,
    INDEX_OPT_GENERATE_DH_PARAMS       = 61,
    INDEX_OPT_GET_DH_PARAMS            = 62,
    INDEX_OPT_DH_INFO                  = 63,
    INDEX_OPT_LOAD_PRIVKEY             = 64,
    INDEX_OPT_LOAD_PUBKEY              = 65,
    INDEX_OPT_LOAD_REQUEST             = 66,
    INDEX_OPT_LOAD_CERTIFICATE         = 67,
    INDEX_OPT_LOAD_CA_PRIVKEY          = 68,
    INDEX_OPT_LOAD_CA_CERTIFICATE      = 69,
    INDEX_OPT_LOAD_CRL                 = 70,
    INDEX_OPT_LOAD_DATA                = 71,
    INDEX_OPT_PASSWORD                 = 72,
    INDEX_OPT_NULL_PASSWORD            = 73,
    INDEX_OPT_EMPTY_PASSWORD           = 74,
    INDEX_OPT_HEX_NUMBERS              = 75,
    INDEX_OPT_CPRINT                   = 76,
    INDEX_OPT_RSA                      = 77,
    INDEX_OPT_DSA                      = 78,
    INDEX_OPT_ECC                      = 79,
    INDEX_OPT_ECDSA                    = 80,
    INDEX_OPT_HASH                     = 81,
    INDEX_OPT_SALT_SIZE                = 82,
    INDEX_OPT_INDER                    = 83,
    INDEX_OPT_INRAW                    = 84,
    INDEX_OPT_OUTDER                   = 85,
    INDEX_OPT_OUTRAW                   = 86,
    INDEX_OPT_DISABLE_QUICK_RANDOM     = 87,
    INDEX_OPT_TEMPLATE                 = 88,
    INDEX_OPT_STDOUT_INFO              = 89,
    INDEX_OPT_ASK_PASS                 = 90,
    INDEX_OPT_PKCS_CIPHER              = 91,
    INDEX_OPT_PROVIDER                 = 92,
    INDEX_OPT_TEXT                     = 93,
    INDEX_OPT_VERSION                  = 94,
    INDEX_OPT_HELP                     = 95,
    INDEX_OPT_MORE_HELP                = 96
} teOptIndex;
/** count of all options for certtool */
#define OPTION_CT    97
/** certtool version */
#define CERTTOOL_VERSION       "3.6.15"
/** Full certtool version text */
#define CERTTOOL_FULL_VERSION  "certtool 3.6.15"

/**
 *  Interface defines for all options.  Replace "n" with the UPPER_CASED
 *  option name (as in the teOptIndex enumeration above).
 *  e.g. HAVE_OPT(DEBUG)
 */
#define         DESC(n) (certtoolOptions.pOptDesc[INDEX_OPT_## n])
/** 'true' if an option has been specified in any way */
#define     HAVE_OPT(n) (! UNUSED_OPT(& DESC(n)))
/** The string argument to an option. The argument type must be \"string\". */
#define      OPT_ARG(n) (DESC(n).optArg.argString)
/** Mask the option state revealing how an option was specified.
 *  It will be one and only one of \a OPTST_SET, \a OPTST_PRESET,
 * \a OPTST_DEFINED, \a OPTST_RESET or zero.
 */
#define    STATE_OPT(n) (DESC(n).fOptState & OPTST_SET_MASK)
/** Count of option's occurrances *on the command line*. */
#define    COUNT_OPT(n) (DESC(n).optOccCt)
/** mask of \a OPTST_SET and \a OPTST_DEFINED. */
#define    ISSEL_OPT(n) (SELECTED_OPT(&DESC(n)))
/** 'true' if \a HAVE_OPT would yield 'false'. */
#define ISUNUSED_OPT(n) (UNUSED_OPT(& DESC(n)))
/** 'true' if OPTST_DISABLED bit not set. */
#define  ENABLED_OPT(n) (! DISABLED_OPT(& DESC(n)))
/** number of stacked option arguments.
 *  Valid only for stacked option arguments. */
#define  STACKCT_OPT(n) (((tArgList*)(DESC(n).optCookie))->useCt)
/** stacked argument vector.
 *  Valid only for stacked option arguments. */
#define STACKLST_OPT(n) (((tArgList*)(DESC(n).optCookie))->apzArgs)
/** Reset an option. */
#define    CLEAR_OPT(n) STMTS( \
                DESC(n).fOptState &= OPTST_PERSISTENT_MASK;   \
                if ((DESC(n).fOptState & OPTST_INITENABLED) == 0) \
                    DESC(n).fOptState |= OPTST_DISABLED; \
                DESC(n).optCookie = NULL )
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
/**
 *  Enumeration of certtool exit codes
 */
typedef enum {
    CERTTOOL_EXIT_SUCCESS         = 0,
    CERTTOOL_EXIT_FAILURE         = 1,
    CERTTOOL_EXIT_USAGE_ERROR     = 64,
    CERTTOOL_EXIT_LIBOPTS_FAILURE = 70
}   certtool_exit_code_t;
/**
 *  Interface defines for specific options.
 * @{
 */
#define VALUE_OPT_DEBUG          'd'

#define OPT_VALUE_DEBUG          (DESC(DEBUG).optArg.argInt)
#define VALUE_OPT_VERBOSE        'V'
#define VALUE_OPT_INFILE         2
#define VALUE_OPT_OUTFILE        3
#define VALUE_OPT_CERTIFICATE_INFO 'i'
#define VALUE_OPT_PUBKEY_INFO    6
#define VALUE_OPT_GENERATE_SELF_SIGNED 's'
#define VALUE_OPT_GENERATE_CERTIFICATE 'c'
#define VALUE_OPT_GENERATE_PROXY 9
#define VALUE_OPT_UPDATE_CERTIFICATE 'u'
#define VALUE_OPT_FINGERPRINT    11
#define VALUE_OPT_KEY_ID         12
#define VALUE_OPT_CERTIFICATE_PUBKEY 13
#define VALUE_OPT_V1             14
#define VALUE_OPT_SIGN_PARAMS    15
#define VALUE_OPT_CRQ_INFO       17
#define VALUE_OPT_GENERATE_REQUEST 'q'
#define VALUE_OPT_NO_CRQ_EXTENSIONS 19
#define VALUE_OPT_P12_INFO       21
#define VALUE_OPT_P12_NAME       22
#define VALUE_OPT_TO_P12         23
#define VALUE_OPT_KEY_INFO       'k'
#define VALUE_OPT_P8_INFO        26
#define VALUE_OPT_TO_RSA         27
#define VALUE_OPT_GENERATE_PRIVKEY 'p'
#define VALUE_OPT_KEY_TYPE       29
#define VALUE_OPT_BITS           30

#define OPT_VALUE_BITS           (DESC(BITS).optArg.argInt)
#define VALUE_OPT_CURVE          31
#define VALUE_OPT_SEC_PARAM      32
#define VALUE_OPT_TO_P8          129
#define VALUE_OPT_PKCS8          '8'
#define VALUE_OPT_PROVABLE       131
#define VALUE_OPT_VERIFY_PROVABLE_PRIVKEY 132
#define VALUE_OPT_SEED           133
#define VALUE_OPT_CRL_INFO       'l'
#define VALUE_OPT_GENERATE_CRL   136
#define VALUE_OPT_VERIFY_CRL     137
#define VALUE_OPT_VERIFY_CHAIN   'e'
#define VALUE_OPT_VERIFY         140
#define VALUE_OPT_VERIFY_HOSTNAME 141
#define VALUE_OPT_VERIFY_EMAIL   142
#define VALUE_OPT_VERIFY_PURPOSE 143
#define VALUE_OPT_VERIFY_ALLOW_BROKEN 144
#define VALUE_OPT_VERIFY_PROFILE 145
#define VALUE_OPT_P7_GENERATE    147
#define VALUE_OPT_P7_SIGN        148
#define VALUE_OPT_P7_DETACHED_SIGN 149
#define VALUE_OPT_P7_INCLUDE_CERT 150
#define VALUE_OPT_P7_TIME        151
#define VALUE_OPT_P7_SHOW_DATA   152
#define VALUE_OPT_P7_INFO        153
#define VALUE_OPT_P7_VERIFY      154
#define VALUE_OPT_SMIME_TO_P7    155
#define VALUE_OPT_GENERATE_DH_PARAMS 157
#define VALUE_OPT_GET_DH_PARAMS  158
#define VALUE_OPT_DH_INFO        159
#define VALUE_OPT_LOAD_PRIVKEY   160
#define VALUE_OPT_LOAD_PUBKEY    161
#define VALUE_OPT_LOAD_REQUEST   162
#define VALUE_OPT_LOAD_CERTIFICATE 163
#define VALUE_OPT_LOAD_CA_PRIVKEY 164
#define VALUE_OPT_LOAD_CA_CERTIFICATE 165
#define VALUE_OPT_LOAD_CRL       166
#define VALUE_OPT_LOAD_DATA      167
#define VALUE_OPT_PASSWORD       168
#define VALUE_OPT_NULL_PASSWORD  169
#define VALUE_OPT_EMPTY_PASSWORD 170
#define VALUE_OPT_HEX_NUMBERS    171
#define VALUE_OPT_CPRINT         172
#define VALUE_OPT_RSA            173
#define VALUE_OPT_DSA            174
#define VALUE_OPT_ECC            175
#define VALUE_OPT_ECDSA          176
#define VALUE_OPT_HASH           177
#define VALUE_OPT_SALT_SIZE      178

#define OPT_VALUE_SALT_SIZE      (DESC(SALT_SIZE).optArg.argInt)
#define VALUE_OPT_INDER          179
#define VALUE_OPT_INRAW          180
#define VALUE_OPT_OUTDER         181
#define VALUE_OPT_OUTRAW         182
#define VALUE_OPT_DISABLE_QUICK_RANDOM 183
#define VALUE_OPT_TEMPLATE       184
#define VALUE_OPT_STDOUT_INFO    185
#define VALUE_OPT_ASK_PASS       186
#define VALUE_OPT_PKCS_CIPHER    187
#define VALUE_OPT_PROVIDER       188
#define VALUE_OPT_TEXT           189
/** option flag (value) for " (get "val-name") " option */
#define VALUE_OPT_HELP          'h'
/** option flag (value) for " (get "val-name") " option */
#define VALUE_OPT_MORE_HELP     '!'
/** option flag (value) for " (get "val-name") " option */
#define VALUE_OPT_VERSION       'v'
/*
 *  Interface defines not associated with particular options
 */
#define ERRSKIP_OPTERR  STMTS(certtoolOptions.fOptSet &= ~OPTPROC_ERRSTOP)
#define ERRSTOP_OPTERR  STMTS(certtoolOptions.fOptSet |= OPTPROC_ERRSTOP)
#define RESTART_OPT(n)  STMTS( \
                certtoolOptions.curOptIdx = (n); \
                certtoolOptions.pzCurOpt  = NULL )
#define START_OPT       RESTART_OPT(1)
#define USAGE(c)        (*certtoolOptions.pUsageProc)(&certtoolOptions, c)

#ifdef  __cplusplus
extern "C" {
#endif
/*
 *  global exported definitions
 */
#include <gettext.h>


/* * * * * *
 *
 *  Declare the certtool option descriptor.
 */
extern tOptions certtoolOptions;

#if defined(ENABLE_NLS)
# ifndef _
#   include <stdio.h>
#   ifndef HAVE_GETTEXT
      extern char * gettext(char const *);
#   else
#     include <libintl.h>
#   endif

static inline char* aoGetsText(char const* pz) {
    if (pz == NULL) return NULL;
    return (char*)gettext(pz);
}
#   define _(s)  aoGetsText(s)
# endif /* _() */

# define OPT_NO_XLAT_CFG_NAMES  STMTS(certtoolOptions.fOptSet |= \
                                    OPTPROC_NXLAT_OPT_CFG;)
# define OPT_NO_XLAT_OPT_NAMES  STMTS(certtoolOptions.fOptSet |= \
                                    OPTPROC_NXLAT_OPT|OPTPROC_NXLAT_OPT_CFG;)

# define OPT_XLAT_CFG_NAMES     STMTS(certtoolOptions.fOptSet &= \
                                  ~(OPTPROC_NXLAT_OPT|OPTPROC_NXLAT_OPT_CFG);)
# define OPT_XLAT_OPT_NAMES     STMTS(certtoolOptions.fOptSet &= \
                                  ~OPTPROC_NXLAT_OPT;)

#else   /* ENABLE_NLS */
# define OPT_NO_XLAT_CFG_NAMES
# define OPT_NO_XLAT_OPT_NAMES

# define OPT_XLAT_CFG_NAMES
# define OPT_XLAT_OPT_NAMES

# ifndef _
#   define _(_s)  _s
# endif
#endif  /* ENABLE_NLS */

#ifdef  __cplusplus
}
#endif
#endif /* AUTOOPTS_CERTTOOL_ARGS_H_GUARD */

/* certtool-args.h ends here */
